import 'dart:async';
import 'dart:convert';
import 'dart:io';
class Streamer {
  int _current;
  int _mod;
  //chunk size
  int _size;
  //current chunk size
  int _chunk;
  int _length;
  //max size in kb of each chunk
  int _max;
  int _total;
  int _loops;
  File file;
  static int TIMEOUT = 1;
  static StringBuffer buffer;
  Streamer(File file, {chunksize = 100}) {
    this.file = file;
    this._current = 0;
    this._chunk = 0;
    this._size = 0;
    this._max = chunksize;
    this._loops = 0;
  }
  Future<String> next() async {
    Completer<String> completer = new Completer<String>();
    if (this._size > 0) {
      this._serv().then((String value) {
        completer.complete(value);
      }).catchError((error) {
        completer.completeError(error);
      });
    } else {
      file.length().then((int value) {
        this._total = value;
        this._mod = value % 1000;
        this._length = (value - this._mod) ~/ 1000;
        Streamer.TIMEOUT = ((this._length / 1000) / 6).ceil();
        this._size = this._length ~/ this._max;
        this._loops = this._size + (this._mod > 0 ? 1 : 0);
        this._serv().then((String value) {
          completer.complete(value);
        }).catchError((error) {
          completer.completeError(error);
        });
      }).catchError((error) {
        completer.completeError(error);
      });
    }
    return completer.future;
  }

  Future<String> _serv() async {
    Completer<String> completer = new Completer<String>();
    bool done = false;
    int end = this._chunk + (this._max * 1000);
    if (this._chunk == 0 && end > this._total) {
      end = this._total;
    } else if (end > this._total) {
      end = this._total;
    }
    if (this._chunk >= end) {
      done = true;
    }
    if (done || this._current == this._loops) {
      new Timer(new Duration(microseconds: 0), () {
        completer.complete(null);
      });
    } else {
      StringBuffer bf = new StringBuffer();
      Stream<List<int>> inputStream;
      if (end == this._total) {
        inputStream = file.openRead(this._chunk);
      } else {
        inputStream = file.openRead(this._chunk, end);
      }

      inputStream.transform(utf8.decoder) // Decode bytes to UTF-8.
          .listen((String line) {
        bf.write(line);
      }, onDone: () {
        this._chunk = end;
        this._current++;
        completer.complete(bf.toString());
      }, onError: (e) {
        completer.completeError(e);
      });
    }
    return completer.future;
  }
}
